Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# TQPair Class Reference

The TQPair class is a value-based template class that provides a pair of elements. More...

`#include <ntqpair.h>`

List of all member functions.

## Public Members

- typedef T1 first_type
- typedef T2 second_type
- TQPair ()
- TQPair ( const T1 & t1, const T2 & t2 )
- TQPair<T1, T2> & operator= ( const TQPair<T1, T2> & other )

## Related Functions

- TQPair qMakePair ( T1 t1, T2 t2 )

## Detailed Description

The TQPair class is a value-based template class that provides a pair of elements.

TQPair is a TQt implementation of an STL-like pair. It can be used in your application if the standard pair<> is not available on your target platforms.

TQPair<T1, T2> defines a template instance to create a pair of values that contains two values of type T1 and T2. Please note that TQPair does not store pointers to the two elements; it holds a copy of every member. This is why these kinds of classes are called value based. If you're interested in pointer based classes see, for example, TQPtrList and TQDict.

TQPair holds one copy of type T1 and one copy of type T2, but does not provide iterators to access these elements. Instead, the two elements (`first` and `second`) are public member variables of the pair. TQPair owns the contained elements. For more relaxed ownership semantics, see TQPtrCollection and friends which are pointer-based containers.

Some classes cannot be used within a TQPair: for example, all classes derived from TQObject and thus all classes that implement widgets. Only "values" can be used in a TQPair. To qualify as a value the class must provide:

- A copy constructor
- An assignment operator
- A constructor that takes no arguments

Note that C++ defaults to field-by-field assignment operators and copy constructors if no explicit version is supplied. In many cases this is sufficient.

TQPair uses an STL-like syntax to manipulate and address the objects it contains. See the TQTL documentation for more information.

Functions that need to return two values can use a TQPair.

See also TQt Template Library Classes, Implicitly and Explicitly Shared Classes, and Non-GUI Classes.

## Member Type Documentation

### TQPair::first_type

The type of the first element in the pair.

### TQPair::second_type

The type of the second element in the pair.

## Member Function Documentation

### TQPair::TQPair ()

Constructs an empty pair. The `first` and `second` elements are default constructed.

### TQPair::TQPair ( const T1 & t1, const T2 & t2 )

Constructs a pair and initializes the `first` element with t1 and the `second` element with t2.

## Related Functions

### TQPair qMakePair ( T1 t1, T2 t2 )

This is a template convenience function. It is used to create a TQPair<> object that contains t1 and t2.

This file is part of the TQt toolkit. Copyright © 1995-2007 Trolltech. All Rights Reserved.